#include <bits/stdc++.h>
using namespace std;
int main()
{
	ifstream f1; f1.open("MATRANVUONG.INP");
	long int n;
	f1>>n;
	long int a[n][n];
	ofstream f2; f2.open("MATRANVUONG.OUT");
	for(int i=0;i<n;i++)
		for(int j=0;j<n;j++)
			{
				f1>>a[i][j];
			}
	f1.close();
	int tcc=0;
	for(int i=0;i<n;i++)
	{
		tcc=a[i][i]+tcc;
	}
	f2<<tcc<<endl;
	int tcp=0;
	for(int i=0;i<n;i++)
	{
		tcp=tcp+a[i][n-1-i];
	}
	f2<<tcp<<endl;
	int tcsc=0;
	tcsc=a[0][1];
	for(int i=1;i<n-1;i++)
		{
		tcsc=tcsc+a[i][i+1]+a[i][i-1];
		}
	tcsc=tcsc+a[n-1][n-2];
	f2<<tcsc<<endl;
	int tcsp=0;
	tcsp=a[0][n-2];
	for(int i=1;i<n-1;i++)
	{
		tcsp=tcsp+a[i][n-1-i+1]+a[i][n-1-i-1];
	}
	tcsp=tcsp+a[n-1][1];
	f2<<tcsp<<endl;
	int ttcc=0;
	for(int i=0;i<n;i++)
	{
		for(int j=i+1;j<n;j++)
		{
			ttcc=a[i][j]+ttcc;
		}
	}
	f2<<ttcc<<endl;
	int tdcp=0;
	for(int i=n-1;i>0;i--)
	{
 	for(int j=n-i;j<n;j++)
		{
			tdcp=a[i][j]+tdcp;
		}
	}
	f2<<tdcp<<endl;
	f2.close();
}
